/*
 ============================================================================
 Project     : Fitness Algorithm
 Author      : Lucas Angelo Silveira
 Universidade de Brasilia (UnB) - Brazil
 Group of Theory of Computation
 Version     : 1.0
 
 Last Modified On: July 16, 2015.
 ============================================================================
 */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "AdjacencyGraph.c"

//int * chromosomeNbs;
//int * chromNbsGene;
int * greatestPrecursors;
int * smallestPrecursors;
int * greatestSuccessors;
int * smallestSuccessors;
int CONT;

//parameters genome A and B


typedef struct  {
    int startIndex;
    int endIndex;
    int type;
    int oriented;//represents a  boolean variabel
}componente;




 int * generateChromNumbers(int entrada[],int entrada2[], int size)
{
	
   cappingP(entrada, size);//referente the dadosadicionais.c
   cappingM(entrada, size);
    int i;
    int k;
    int * estatusB= status_B(entrada2, size);
    if (estatusB==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, ComponentIndetification.C, LINE 45\n");
    }
    int cappedGenomeLength = qtd_genes + qtd_cromossomo * 2;
    int * chromosomeNbs=(int *) calloc (cappedGenomeLength, sizeof (int));
    if (chromosomeNbs==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, ComponentIndetification.C, LINE 50\n");
    }
	
    int bufferArray[qtd_genes+1];
    bufferArray[0]=0;
	
    
    // For each gene in B save the corresponding chromosome number
    // at position array[gene] in the bufferArray
   
    for (i = 0; i <qtd_cromossomo; i++) {
       
        for(k=0; k<estatusB[i]; k++) {
            bufferArray[abs(GENOMA_B[i][k])] = i + 1;
        }//end for internal
        
    }//end for external
    
       // Assign for a gene in A it's chromosome number in B.
    //resumindo aqui verifica onde deveria estar cada gene para q esteja iqual ao cromossomo alvo
    for ( i = 0; i < TAMANHO_CAPPEPLUS; ++i) {
        
        if (genomeCappedPlus[i] != 0 && genomeCappedPlus[i] != qtd_genes+1)
        {
            chromosomeNbs[i] = bufferArray[abs(genomeCappedPlus[i])];
        }
        else
        {
            if (genomeCappedPlus[i] == 0)
            { // front cap
                chromosomeNbs[i] = bufferArray[abs(genomeCappedPlus[i + 1])];
            }
            else
            { // back cap
                chromosomeNbs[i] = bufferArray[abs(genomeCappedPlus[i - 1])];
            }
        }//end else
    }
    
    free(estatusB);

    return chromosomeNbs;
}//end generatechromNumbers





//    representing of the genome B
int * calcChromNbsGene(int entrada2[], int size){
    
    
    //printf("quanto que vale size %d",size);
    int *ci=(int *) calloc (qtd_genes+1, sizeof (int));
   
    int * estatusB= status_B(entrada2, size);
    if (estatusB==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, ComponentIndetification.C, LINE 107\n");
    }
    int count = 1;
    int i,j;
    //representing o size of the genome B
    for (i = 0; i <qtd_cromossomo; ++i)
    {
        for(j=0; j<estatusB[i]; j++)
        {
            ci[count++] = i;
        }
    }
    
   
    
    free(estatusB);
    
    return ci;
    

}//end caclchromNbsGene




/**
 * Preprocessing of the plus capped genome for component identification. The
 * Stacks M & m are created, which contain possible start positions for a
 * component. The preprocessing procedure is finding for each gene the
 * greatest and smallest precursor in the plus capped genome.
 *
 * @return Returns a pair containing the greatestPrecursor array as first
 * element and the smallestPrecursor array as second element.
 */
void plusCappedPreprocessing(int entrada[], int size, int first)// ultimo parametro para verificar se eh preciso inicializar os arrays
{
      cappingP(entrada, size);//referente the dadosadicionais.c
     int cappedGenomeLength = TAMANHO_CAPPEPLUS;//size of the genomeCappedPlus
    if (first) {
        greatestPrecursors= (int *) calloc (cappedGenomeLength, sizeof (int));
        if (greatestPrecursors==NULL) {
            printf("ATENCAO PERCA DE MEMORIA, ComponentIndetification.C, LINE 148\n");
        }
        
        smallestPrecursors= (int *) calloc (cappedGenomeLength, sizeof (int));
        if (smallestPrecursors==NULL) {
            printf("ATENCAO PERCA DE MEMORIA, ComponentIndetification.C, LINE 153\n");
        }
    
    }
    int i,j;
    int cont_m1;
    int cont_m2;
    int nbOfGenes=qtd_genes;
    int m1[qtd_genes+1];
    int m2[qtd_genes+1];
    int nbOfGenesPlus1 = nbOfGenes + 1;
    for ( i = 0; i < cappedGenomeLength; i++) {
        
        cont_m1=-1;
        cont_m2=-1;
        
        for (j=0; j< nbOfGenesPlus1;j++) {
            
                m1[j]= 0;
                m2[j]=0;
            }
            
            
        greatestPrecursors[i] = nbOfGenesPlus1;
        smallestPrecursors[i] = 0;
        cont_m1++;
        m1[cont_m1]=nbOfGenesPlus1;
        cont_m2++;
         m2[cont_m2]=0;
          ++i;
            
        
        while (genomeCappedPlus[i] < nbOfGenesPlus1) {
            //  System.out.println("plusCappedGenomeAArray[i] < nbOfGenesPlus1:" + plusCappedGenomeAArray[i] + " < " + nbOfGenesPlus1 + " sou o i:" + i);
            

            
            int prevValue = abs(genomeCappedPlus[i - 1]);
            //System.out.println("sou prev:" + prevValue);
            int currentValue = abs(genomeCappedPlus[i]);
            //System.out.println("sou corrente:" + currentValue);
            // Compute the M[i] aka greatestPrecursos[i]
            if (prevValue > currentValue) {
                    cont_m1++;
                m1[cont_m1]=prevValue;
                
            }
            else
            {
                //   System.out.println("sou m1.peek:" + m1.peek());
                while (m1[cont_m1] < currentValue) {
                   cont_m1=cont_m1-1;
                }
            }//end else
            
            // System.out.println("guardei  m1.peek:" + m1.peek());
            greatestPrecursors[i] = m1[cont_m1];
            
            // Compute the m[i] aka smallestPrecursors[i]
            if (prevValue < currentValue)
            {
                cont_m2++;
                m2[cont_m2]=prevValue;
                
            }
            else
            {
                //    System.out.println("m2.peek:" + m2.peek());
                while ((m2[cont_m2] > currentValue) && (m2[cont_m2] != nbOfGenesPlus1)) {
                    cont_m2=cont_m2-1;
                }
            }//end else
            
            //System.out.println(" guardei o m2.peek:" + m2.peek());
            smallestPrecursors[i] = m2[cont_m2];
            ++i;
        }//fim while
        
        greatestPrecursors[i] = nbOfGenesPlus1;
        smallestPrecursors[i] = 0;
        
    }//end for

    

}// end plusCappedPreprocessing


/**
 * Preprocessing of the minus capped genome for component identification.
 * The Stacks M & m are created, which contain possible start positions for
 * a component. The preprocessing procedure here is finding for each gene
 * the greatest and smallest successor in the minus capped genome.
 *
 * @param minusCappedGenomeAArray The minus capped array of genes of genome
 * A.
 * @param nbOfGenes The number of genes of the pre-processed genome
 * @return Returns a pair containing the greatestSuccessor array as first
 * element and the smallestSuccessor array as second element.
 */
void minusCappedPreprocessing(int entrada[], int size, int first){
    int i,cont_m1,cont_m2,j;
    //genomeCappedMinus
     cappingM(entrada, size);
    int cappedGenomeLength = TAMANHO_CAPPEPLUS;//size of the genomeCappedPlus
    if (first) {
        greatestSuccessors= (int *) calloc (cappedGenomeLength, sizeof (int));
        if (greatestSuccessors==NULL) {
            printf("ATENCAO PERCA DE MEMORIA, ComponentIndetification.C, LINE 261\n");
        }
        smallestSuccessors= (int *) calloc (cappedGenomeLength, sizeof (int));
        if (smallestSuccessors==NULL) {
            printf("ATENCAO PERCA DE MEMORIA, ComponentIndetification.C, LINE 265\n");
        }
    
    }
    int nbOfGenesPlus1 = qtd_genes + 1;
    for (i = cappedGenomeLength - 1; i > 0; --i) {
        
        greatestSuccessors[i] = nbOfGenesPlus1;
        smallestSuccessors[i] = 0;
        int m1[nbOfGenesPlus1];
        int m2[nbOfGenesPlus1];
        cont_m1=-1;
        cont_m2=-1;
            
         for (j=0; j< nbOfGenesPlus1;j++) {
                
                m1[j]= 0;
                m2[j]=0;
         }
            
        
         cont_m1++;
         m1[cont_m1]=nbOfGenesPlus1;
         cont_m2++;
         m2[cont_m2]=0;
         --i;
        
        while (i >= 0 && genomeCappedMinus[i] <= qtd_genes) {
            int consecValue = abs(genomeCappedMinus[i + 1]);
            int currentValue= abs(genomeCappedMinus[i]);
            if (consecValue > currentValue)
            {
                cont_m1++;
                m1[cont_m1]=consecValue;
            }
            else
            {
                while ((m1[cont_m1] < currentValue) && (m1[cont_m1] != nbOfGenesPlus1)) {
                    cont_m1=cont_m1-1;// do pop
                }
            }
            greatestSuccessors[i] = m1[cont_m1];
            
            if ((consecValue < currentValue) && (currentValue != nbOfGenesPlus1))
            {   cont_m2++;
                m2[cont_m2]=consecValue;
            }
            else
            {
                while ((m2[cont_m2] > currentValue && m2[cont_m2] != 0) || (currentValue == nbOfGenesPlus1 && m2[cont_m2] != 0)) {
                    cont_m2=cont_m2-1;//do pop
                }
            }
            smallestSuccessors[i] = m2[cont_m2];
            --i;
        }//end while
    }// end for

 
   // free(genomeCappedMinus);
    
}//end minusCappedPreprocessing

int min( int x, int y){

    if (x<y) {
        return x;
    }
    else
        return y;

}

int max( int x, int y){
    
    if (x>y) {
        return x;
    }
    else
        return y;
    
}




/**
 * Returns the extremity for a given start end endposition gene for getting
 * the orientation for components of type IV and VIII.
 *
 * @param gene the gene whose adjacency is needed
 * @param startPos true if it is a start position of the component
 * @param direct true if it is a component of type IV = direct component
 * @return the extremity
 */
int getExtremity(int gene, int startPos, int direct) {
    if ((startPos && direct) || (!startPos && !direct)) {
        return (abs(gene)) * 2 - 1;
    }
    return (abs(gene)) * 2;
}

void desaloca_memoria()
{
   
    free(greatestPrecursors);
    free(smallestPrecursors);
    free( greatestSuccessors);
    free(smallestSuccessors);
    
}

/*
 * oriD & oriR save for the components of type I-III and V-VII if the elements of the component have both signs.
 * Starting with assumption that all elements are positive for direct or negative for reverse components. Then
 * in each step it is updated and if a minus is detected in direct comp or a plus reversed comp then the last
 * potential starting position is updated and if the starting pos is popped from S1/S2 the information of the
 * new start position & the popped one is put together by oriD[topS1] |= oriD[startPos] Remember that a
 * component containing other components is oriented or not according to its blocks and the associated
 * permutation. The permutation of the blocks needs to have pos and neg sign for an oriented component! For
 * components of type IV and VIII its more complicated: even path array added
 */

/**
 * Phase two of the component identification. Here directed components of
 * type 2 (semi-real) and reversed components of type 5 (real), 6
 * (semi-real) and 8 (semi-real) are identified by going from right to left
 * through the minus capped genome.
 *
 * @param minusCapGnom minusCappedGenome
 * @param greatSucc greatest successors
 * @param smallSucc smallest successors
 * @param nbGenes number of genes
 * @param chromNbs chromosome numbers in B
 * @param chromNbsGene chromosome numbers in B in gene order
 * @return An ArrayList of Components identified in this step.
 */

//genomeCappedMinus, greatestSuccessors,csmallestSuccessors, final int nbGenes,chromosomeNbs, chromNbsGene
componente * compIdentificationPhase12(int nbGenes, int entrada[],int entrada2[], int siz) {
    
    cappingP(entrada,siz);//referente the dadosadicionais.c =plusCapGnom
    int QTD_COMPONENTES=0;
    //struct componente * components=[(int)TAMANHO_CAPPEPLUS/3];
    int * chromNbsGene = calcChromNbsGene(entrada2, siz);//=chromNbsGene
    if (chromNbsGene==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, ComponentIndetification.C, LINE 412\n");
    }
    
    componente * components = malloc ((TAMANHO_CAPPEPLUS)* sizeof (componente));
    if (components==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, ComponentIndetification.C, LINE 418\n");
    }
    
    
    int *chromosomeNbs=generateChromNumbers(entrada,entrada2,siz);//=chromNbs
    if (chromosomeNbs==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, ComponentIndetification.C, LINE 423\n");
    }
    
    int *belongToEvenP= calculatePathsAndCycles(entrada, entrada2, siz);
    if (belongToEvenP==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, ComponentIndetification.C, LINE 429\n");
    }
    
    int size = TAMANHO_CAPPEPLUS;
        int nPlus1 = nbGenes + 1;
        int s1 [size]; // stacks containing the potential start positions
        int s2 [size];
        int minDir[size]; // contain the minimum or maximum between current index
        int maxDir[size]; // i and a potential start position
        int minRev[size];
        int maxRev[size];
        int oriD [size]; // saves if comp is oriented due to unequal signs in comp
        int oriR [size];
        int chrD [size]; // for checking if all genes are on same chrom in 1 comp
        int chrR [size];
        int grey [size]; // contains for a chromosome if there is a grey component on it
        int startPos = 0;
        int falsch = 0;
        int wahr = 1;
        int i,j,size_p1,size_p2;
    
        for (i = 0; i < size; ++i)
        {
            
            size_p1=-1;
            size_p2=-1;
            for (j=0; j<size; j++)
            {
                s1[j]=0;
                s2[j]=0;
            }//end for
            
            size_p1++;
            size_p2++;
            s1[size_p1]=i;
            s2[size_p2]=i;
            minDir[i] = nbGenes;
            maxDir[i] = 0;
            minRev[i] = nbGenes;
            maxRev[i] = 0;
            oriD[i] = falsch;
            oriR[i] = falsch;
            chrD[i] = chromosomeNbs[i];
            chrR[i] = chromosomeNbs[i];
            int currentGene = 0;
            int topS1 = i;
            int topS2 = i;
            ++i;
            
            // in a chromosome nPlus qtd genes +1
            while (currentGene != nPlus1) {
                
                // Update minima and maxima
                topS1 = s1[size_p1];
                topS2 = s2[size_p2];
                currentGene = abs(genomeCappedPlus[i]);
                minDir[i] = currentGene;
                minDir[topS1] = min(minDir[topS1], currentGene);
                maxDir[i] = currentGene;
                maxDir[topS1] = max(maxDir[topS1], currentGene);
                minRev[i] = currentGene;
                minRev[topS2] = min(minDir[topS2], currentGene);
                maxRev[i] = currentGene;
                maxRev[topS2] = max(maxDir[topS2], currentGene);
                
                // Find direct components of type I and III [i-j], [0-j]
                //  System.out.println("current Gene < Math.abs(plusCapGnom[startPos = topS1]) "+ currentGene+ "<"+Math.abs(plusCapGnom[startPos = topS1])+ "|| currentGene > greatPrec[startPos]"+currentGene+">"+greatPrec[startPos]);
                while (currentGene < abs(genomeCappedPlus[startPos = topS1]) || currentGene > greatestPrecursors[startPos]) {
                    size_p1=size_p1-1;
                    topS1 = s1[size_p1];
                    // update signs array
                    // this.signs[topS1] = this.signFunction(this.signs[topS1], this.signs[startPos]);
                    // Update minima and maxima
                    minDir[topS1] = min(minDir[topS1], minDir[startPos]);
                    maxDir[topS1] = max(maxDir[topS1], maxDir[startPos]);
                    oriD[topS1] |= oriD[startPos]; // for shifting information to the left, when a startpos is removed
                    //    System.out.println("chrD[topS1] != chrD[startPos] "+ chrD[topS1] +"!="+chrD[startPos]);
                    if (chrD[topS1] != chrD[startPos]) {
                        chrD[topS1] = -1;
                    }
                }
                // report component
             // printf("posicao i=%d valor current %d != %d\n",genomeCappedPlus[i],minDir[startPos] ,(minDir[startPos] - 1));
                if (genomeCappedPlus[i] >= 0 //v
                    && currentGene == maxDir[startPos]//v
                    && chrD[startPos] == chromosomeNbs[i]
                    && ((genomeCappedPlus[startPos] == 0//v
                         && maxDir[startPos] - minDir[startPos] == i - startPos - 1//v
                         && (minDir[startPos] == 1 || chromNbsGene[minDir[startPos]] != chromNbsGene[minDir[startPos] - 1]))
                        || (genomeCappedPlus[startPos] != 0 && maxDir[startPos]- minDir[startPos] == i - startPos))) {
                        //  System.out.println("entrei dentro do primeiro se enorme");
                        int type = 1;
                        //System.out.println("plusCapGnom[startPos] == 0:"+plusCapGnom[startPos] );
                        if (genomeCappedPlus[startPos] == 0) {
                            
                            //System.out.println("grey[chromNbs[i]] = wahr:"+chromNbs[i]+" "+wahr );
                            grey[chromosomeNbs[i]] = wahr;
                            type = 3;
                        }
                        //System.out.println("oriD[startPos] == falsch:"+oriD[startPos]+"=="+falsch + "i="+i );
                        if (oriD[startPos] == falsch) {
                            
                            components[QTD_COMPONENTES].startIndex=startPos;
                            components[QTD_COMPONENTES].endIndex=i;
                            components[QTD_COMPONENTES].type=type;
                            components[QTD_COMPONENTES].oriented=0;//false
                            QTD_COMPONENTES++;
                            // System.out.println("Start: "+startPos+", i: "+i+", type: "+type+", oriented: "+false);
                        } else {
                            components[QTD_COMPONENTES].startIndex=startPos;
                            components[QTD_COMPONENTES].endIndex=i;
                            components[QTD_COMPONENTES].type=type;
                            components[QTD_COMPONENTES].oriented=1;//true
                            QTD_COMPONENTES++;
                        }
                        
                        oriD[topS1] = falsch;
                        // this.signs[startPos] = ComponentIdentification.PLUS;
                    }
                
                // Find components of type VII [-(N+1)], [-i]
                // System.out.println("currentGene > Math.abs(plusCapGnom[startPos = topS2]" + currentGene+ ">"+ Math.abs(plusCapGnom[startPos = topS2])+"plusCapGnom[startPos] != 0"+plusCapGnom[startPos]);
                while ((currentGene > abs(genomeCappedPlus[startPos = topS2]) || currentGene < smallestPrecursors[startPos])
                       && genomeCappedPlus[startPos] != 0) {
                    size_p2=size_p2-1;//pop
                    topS2 = s2[size_p2];
                    // update signs array
                    // this.signs[topS2] = this.signFunction(this.signs[topS2], this.signs[startPos]);
                    // Update minima and maxima
                    minRev[topS2] = min(minRev[topS2], minRev[startPos]);
                    maxRev[topS2] = max(maxRev[topS2], maxRev[startPos]);
                    oriR[topS2] = oriR[startPos];
                    //   System.out.println("zchrR[topS2] != chrR[startPos]"+chrR[topS2]+ "!="+ chrR[startPos]);
                    if (chrR[topS2] != chrR[startPos]) {
                        chrR[topS2] = -1;
                    }
                }
                
                // report component
                if (genomeCappedPlus[i] <= 0
                    && currentGene == minRev[startPos]
                    && chrR[startPos] == chromosomeNbs[i]
                    && ((genomeCappedPlus[startPos] == 0 && maxRev[startPos] - minRev[startPos] == i - startPos - 1 && (maxRev[startPos] == nbGenes || chromNbsGene[maxRev[startPos] + 1] != chromNbsGene[maxRev[startPos]]))
                        || (genomeCappedPlus[startPos] != 0 && maxRev[startPos]- minRev[startPos] == i - startPos))) {
                        // System.out.println("entrei dentro do segundo se enorme");
                        
                        // System.out.println("plusCapGnom[startPos] == 0"+ plusCapGnom[startPos]);
                        if (genomeCappedPlus[startPos] == 0) {
                            
                            if (oriR[startPos] == falsch) {
                                //components.add(new Component(startPos, i, 7, false));
                                components[QTD_COMPONENTES].startIndex=startPos;
                                components[QTD_COMPONENTES].endIndex=i;
                                components[QTD_COMPONENTES].type=7;
                                components[QTD_COMPONENTES].oriented=0;//false
                                QTD_COMPONENTES++;
                                
                            }
                            
                            else
                            {
                                //components.add(new Component(startPos, i, 7, true));
                                components[QTD_COMPONENTES].startIndex=startPos;
                                components[QTD_COMPONENTES].endIndex=i;
                                components[QTD_COMPONENTES].type=7;
                                components[QTD_COMPONENTES].oriented=1;//true
                                QTD_COMPONENTES++;
                                
                            }
                            grey[chromosomeNbs[i]] = wahr;
                        }
                        oriR[topS2] = falsch;
                        // this.signs[startPos] = ComponentIdentification.MINUS;
                    }
                
                // Update stacks
                if (genomeCappedPlus[i] >= 0)
                {
                    size_p1++;
                    s1[size_p1]=i;
                    
                    topS1 = s1[size_p1];
                    chrD[topS1] = chromosomeNbs[i];
                    if (chrR[topS2] != chromosomeNbs[i])
                    { // if gene is on other chrom no comp can be here!
                        chrR[topS2] = -1;
                    }
                }
                else
                {
                    size_p2++;
                    s2[size_p2]=i;
                    topS2 = s2[size_p2];
                    chrR[topS2] = chromosomeNbs[i];
                    if (chrD[topS1] != chromosomeNbs[i])
                    {
                        chrD[topS1] = -1;
                    }
                }
                
                oriD[topS1] = genomeCappedPlus[i] >= 0 ? falsch : wahr;
                oriR[topS2] = genomeCappedPlus[i] >= 0 ? wahr : falsch;
                
                ++i;
                currentGene = abs(genomeCappedPlus[i]);
            }
            
            // At chromosome end test for whole chrom = grey component
            // Find components of type IV
            while (genomeCappedPlus[startPos = topS1] != 0) {
                size_p1--;//making pop
                topS1 = s1[ size_p1];
                // update signs array
                // Update minima and maxima
                minDir[topS1] = min(minDir[topS1], minDir[startPos]);
                maxDir[topS1] = max(maxDir[topS1], maxDir[startPos]);
                if (chrD[topS1] != chrD[startPos]) {
                    chrD[topS1] = -1;
                }
            }
            if (genomeCappedPlus[startPos + 1] > 0 // 1. vorzeichen ein +, länger als 2, bedingung für länge, gleiches chrom
                // alle g,
                && maxDir[startPos] - minDir[startPos] == i - startPos - 2 // linkes & rechts chrom ende
                && chrD[startPos] == chromosomeNbs[i] // es gibt nicht schon ne comp am comp start, ist nicht sortiert
                && (minDir[startPos] == 1 || chromNbsGene[minDir[startPos]] != chromNbsGene[minDir[startPos] - 1])
                && (maxDir[startPos] == nbGenes || chromNbsGene[maxDir[startPos]] != chromNbsGene[maxDir[startPos] + 1])
                && grey[chromosomeNbs[startPos]] == falsch) {
                
                int extremity1 = getExtremity(genomeCappedPlus[startPos + 1], 1, 1);
                int extremity2 = getExtremity(genomeCappedPlus[i - 1], 0, 1);
                
                
                if ((oriD[startPos] == wahr || belongToEvenP[extremity1]) && belongToEvenP[extremity2]) { // hier
                      components[QTD_COMPONENTES].startIndex=startPos;
                    components[QTD_COMPONENTES].endIndex=i;
                    components[QTD_COMPONENTES].type=4;
                    components[QTD_COMPONENTES].oriented=1;//true
                    QTD_COMPONENTES++;
                    
                }
                else {
                    components[QTD_COMPONENTES].startIndex=startPos;
                    components[QTD_COMPONENTES].endIndex=i;
                    components[QTD_COMPONENTES].type=4;
                    components[QTD_COMPONENTES].oriented=0;//true
                    QTD_COMPONENTES++;
                }
               
            }//fim do if
        }//fim do for
        
   /////////////////////////////////////////////////////////////////////////////////////////////////
  // End to component phase 1-----------------------------------------------------------------------
  //////////////////////////////////////////////////////////////////////////////////////////////////


  ////////////////////////////////////////////////////////////////////////////////////////////////////
  // start to component phase 2-----------------------------------------------------------------------
  ////////////////////////////////////////////////////////////////////////////////////////////////////
   
     cappingM(entrada, siz);   
     startPos = 0;
     falsch = 0;
     wahr = 1; 
  //clear arrray
   for(i=0;i<size;i++)
    {
	  s1[i]=0;
          s2 [i]=0; 	
          minDir[i]=0;
	  maxDir[i]=0;
          minRev[i]=0;
          maxRev[i]=0;
	  oriD [i]=0;
	  oriR [i]=0;
	  chrD [i]=0;
	  chrR [i]=0;
	  grey [i]=0;  


    }
    
    for (i = size - 1; i > 0; --i) {
        size_p1=-1;
        size_p2=-1;
        for (j=0; j<size; j++)
        {
            s1[j]=0;
            s2[j]=0;
        }//end for
        size_p1++;
        size_p2++;
        s1[size_p1]=i;
        s2[size_p2]=i;
        minDir[i] = nbGenes;
        maxDir[i] = 0;
        minRev[i] = nbGenes;
        maxRev[i] = 0;
        oriD[i] = falsch;
        oriR[i] = falsch;
        chrD[i] = chromosomeNbs[i];
        chrR[i] = chromosomeNbs[i];
        int currentGene = 0;
        int topS1 = i;
        int topS2 = i;
        --i;
        
        // Within a chromosome
        while (currentGene != nPlus1)
        {
            
            // Update minima and maxima
            topS1 = s1[size_p1];
            topS2 = s2[size_p2];
            currentGene = abs(genomeCappedMinus[i]);
		
   
            minDir[i] = currentGene;
            minDir[topS1] = min(minDir[topS1], currentGene);
            //printf("um duvida minDir[tops1] %d\n", minDir[topS1]);
            maxDir[i] = currentGene;
            maxDir[topS1] = max(maxDir[topS1], currentGene);
            minRev[i] = currentGene;
            minRev[topS2] = min(minDir[topS2], currentGene);
            maxRev[i] = currentGene;
            maxRev[topS2] = max(maxDir[topS2], currentGene);
            
            // Find components of type V and VI [-(i+j) till i], [-(i+j) till 0]
          //  printf(" testando pra ver se entra no primeiro while  meu i %d e topS1 %d currentGene %d\n ",i,topS1,currentGene);

            while (currentGene < abs(genomeCappedMinus[startPos = topS1]) || currentGene > greatestSuccessors[startPos])
            {
              //  printf("entrei no primeiro while o meu i %d e currentgene %d\n ",i,currentGene);
                size_p1--;
                topS1 = s1[size_p1];
                // this.signs[topS1] = this.signFunction(this.signs[topS1], this.signs[startPos]);
                // Update minima and maxima
                minDir[topS1] = min(minDir[topS1], minDir[startPos]);
                maxDir[topS1] = max(maxDir[topS1], maxDir[startPos]);
                oriD[topS1] = oriD[startPos];
                if (chrD[topS1] != chrD[startPos]) {
                    chrD[topS1] = -1;
                }
            }
            
            //printf("e agora  meu i %d e startpos %d currentGene %d\n ",i,startPos, currentGene);
            

            // report component
            if (genomeCappedMinus[i] <= 0
                && currentGene == maxDir[startPos]
                && chrD[startPos] == chromosomeNbs[i]
                && ((genomeCappedMinus[startPos] == 0 && maxDir[startPos] - minDir[startPos] == startPos - i - 1 && (minDir[startPos] == 1 || chromNbsGene[minDir[startPos]] != chromNbsGene[minDir[startPos] - 1])) || (genomeCappedMinus[startPos] != 0 && maxDir[startPos]- minDir[startPos] == startPos - i)))
            {
                int type = 5;
                if (genomeCappedMinus[startPos] == 0) {
                    grey[chromosomeNbs[i]] = wahr;
                    type = 6;
                }
                
                if (oriD[startPos] == falsch)
                {
                    components[QTD_COMPONENTES].startIndex=i;
                    components[QTD_COMPONENTES].endIndex=startPos;
                    components[QTD_COMPONENTES].type=type;
                    components[QTD_COMPONENTES].oriented=0;//false
                    QTD_COMPONENTES++;
                   // components.add(new Component(i, startPos, type, false));
                }
                else
                {
                    components[QTD_COMPONENTES].startIndex=i;
                    components[QTD_COMPONENTES].endIndex=startPos;
                    components[QTD_COMPONENTES].type=type;
                    components[QTD_COMPONENTES].oriented=1;//false
                    QTD_COMPONENTES++;
                    //components.add(new Component(i, startPos, type, true));
                }
                
                oriD[topS1] = falsch;
                // this.signs[i] = ComponentIdentification.MINUS;
            }
            
            //printf("testando no while type 2 o meu i %d e currentgene %d q porra e essa %d\n",i,currentGene,startPos = topS2);
            
            
            // Find components of type I & II but only report II: [i till N+1]
            while ((currentGene > abs(genomeCappedMinus[startPos = topS2]) || currentGene < smallestSuccessors[startPos]) && genomeCappedMinus[startPos] != 0)
            {
              //  printf("entrei no segundo while type 2 o meu i %d e currentgene %d\n ",i,currentGene);
                
                
                size_p2--;
                topS2 = s2[size_p2];
                // update signs array
                // this.signs[topS2] = this.signFunction(this.signs[topS2], this.signs[startPos]);
                // Update minima and maxima
                minRev[topS2] = min(minRev[topS2], minRev[startPos]);
                maxRev[topS2] = max(maxRev[topS2], maxRev[startPos]);
                oriR[topS2] |= oriR[startPos];
                if (chrR[topS2] != chrR[startPos]) {
                    chrR[topS2] = -1;
                }
            }
            
            // report component
            //printf("testando report meu i %d e startPos %d\n ",i,startPos);
            
            if (genomeCappedMinus[i] >= 0
                && currentGene == minRev[startPos]
                && chrR[startPos] == chromosomeNbs[i]
                && ((genomeCappedMinus[startPos] == 0 && maxRev[startPos] - minRev[startPos] == startPos - i - 1 && (maxRev[startPos] == nbGenes || chromNbsGene[maxRev[startPos] + 1] != chromNbsGene[maxRev[startPos]])) || (genomeCappedMinus[startPos] != 0 && maxRev[startPos]- minRev[startPos] == startPos - i)))
            {
              //  printf("entrei nesse if enorme currentGene %d minRev[startPos] %d ????\n", currentGene,minRev[startPos]);
                
                if (genomeCappedMinus[startPos] == 0) {
                    if (oriR[startPos] == falsch) {
                        components[QTD_COMPONENTES].startIndex=i;
                        components[QTD_COMPONENTES].endIndex=startPos;
                        components[QTD_COMPONENTES].type=2;
                        components[QTD_COMPONENTES].oriented=0;//false
                        QTD_COMPONENTES++;
                        
                    }
                    
                    else
                    {
                        components[QTD_COMPONENTES].startIndex=i;
                        components[QTD_COMPONENTES].endIndex=startPos;
                        components[QTD_COMPONENTES].type=2;
                        components[QTD_COMPONENTES].oriented=1;//false
                        QTD_COMPONENTES++;
                        //components.add(new Component(i, startPos, 2, true));
                    }
                    grey[chromosomeNbs[i]] = wahr;
                }
                oriR[topS2] = falsch;
                // this.signs[i] = ComponentIdentification.PLUS;
            }
            
            // Update stacks
            if (genomeCappedMinus[i] <= 0) {
                size_p1++;
                s1[size_p1]=i;
                topS1 = s1[size_p1];
                chrD[topS1] = chromosomeNbs[i];
                if (chrR[topS2] != chromosomeNbs[i]) {
                    chrR[topS2] = -1;
                }
            }
            else
            {
                size_p2++;
                s2[size_p2]=i;
                topS2 = s2[size_p2];
                chrR[topS2] = chromosomeNbs[i];
              //  printf("testando dentro do else meu i %d e chrD[topS1] %d\n ",i,chrD[topS1]);

                if (chrD[topS1] != chromosomeNbs[i]) {
                    chrD[topS1] = -1;
                }
            }
            
            // update marks
            //printf("testando quanto q vale tops1 %d e tops2 %d meu i %d wahr %d falsch %d \n ",topS1,topS2,i,wahr,falsch);

            oriD[topS1] = genomeCappedMinus[i] >= 0 ? wahr : falsch;
            oriR[topS2] = genomeCappedMinus[i] >= 0 ? falsch : wahr;
  
            --i;
           
            currentGene = abs(genomeCappedMinus[i]);
            //printf("***********************************atualizando currentGene %d **************\n ",currentGene);

            
        }
        
        // At chromosome end test for whole chrom = grey component
        // Find components of type VIII
        while (genomeCappedMinus[startPos = topS1] != 0)
        {
           //printf("entrei no while 3\n");
            size_p1--;
            topS1 = s1[size_p1];
            // this.signs[topS1] = this.signFunction(this.signs[topS1], this.signs[startPos]);
            // Update minima and maxima
            minDir[topS1] = min(minDir[topS1], minDir[startPos]);
            maxDir[topS1] = max(maxDir[topS1], maxDir[startPos]);
            if (chrD[topS1] != chrD[startPos]) {
                chrD[topS1] = -1;
            }
        } // report component
        if (genomeCappedMinus[startPos - 1] < 0
            && maxDir[startPos] - minDir[startPos] == startPos - i - 2
            && chrD[startPos] == chromosomeNbs[i]
            && (minDir[startPos] == 1 || chromNbsGene[minDir[startPos]] != chromNbsGene[minDir[startPos] - 1])
            && (maxDir[startPos] == nbGenes || chromNbsGene[maxDir[startPos]] != chromNbsGene[maxDir[startPos] + 1])
            && grey[chromosomeNbs[startPos]] == falsch) {
            
            int extremity1 = getExtremity(genomeCappedMinus[i + 1], 1, 0);
            int extremity2 = getExtremity(genomeCappedMinus[startPos - 1], 0, 0);
            if ((oriD[startPos] == wahr || belongToEvenP[extremity1]) && belongToEvenP[extremity2])
            {
                components[QTD_COMPONENTES].startIndex=i;
                components[QTD_COMPONENTES].endIndex=startPos;
                components[QTD_COMPONENTES].type=8;
                components[QTD_COMPONENTES].oriented=1;//false
                QTD_COMPONENTES++;
                //components.add(new Component(i, startPos, 8, true));
            }
            
            else
            {
                components[QTD_COMPONENTES].startIndex=i;
                components[QTD_COMPONENTES].endIndex=startPos;
                components[QTD_COMPONENTES].type=8;
                components[QTD_COMPONENTES].oriented=0;//false
                QTD_COMPONENTES++;
                
            }
        }
    }//end for
    
       
CONT=QTD_COMPONENTES;//setando a variavel global para a qtd de componentes
free(chromNbsGene);
free(chromosomeNbs);
free(belongToEvenP);
  return components ;
}

//need of the data computed by adjacencygraph


void identifyComponents(int entrada[],int entrada2[], int size,int first)
{
   
    //printf("cheguei \n");
    adjacencygraph(entrada,entrada2,  size);
     //aqui ta o problema
    //printf("cheguei2 \n");

     generateChromNumbers(entrada, entrada2, size);// traz a position of each gene in the crhomossomo in function of b and has 2* number chromosso + qtd_genes with
    //printf("cheguei 3\n");


    //chromNbsGene=calcChromNbsGene(entrada2, size);
    plusCappedPreprocessing(entrada, size,first);// validado
    //printf("cheguei 4\n");
    
    minusCappedPreprocessing(entrada, size,first);//validado
  //  componente*  COMPONENTS=compIdentificationPhase12( qtd_genes,  entrada, entrada2,size);
    //printf("cheguei 5\n");

}
void identifyComponents2(int entrada[],int entrada2[], int size,int first)
{
    
    set_TAMANHO_CAPPEPLUS(entrada, size);//seta size of the Plus e MIN
    adjacencygraph(entrada,entrada2,  size);
    //aqui ta o problema
	
    generateChromNumbers(entrada, entrada2, size);// traz a position of each gene in the crhomossomo in function of b and has 2* number chromosso + qtd_genes with
    
    
    //chromNbsGene=calcChromNbsGene(entrada2, size);
    plusCappedPreprocessing(entrada, size,first);// validado
    minusCappedPreprocessing(entrada, size,first);//validado
    //  componente*  COMPONENTS=compIdentificationPhase12( qtd_genes,  entrada, entrada2,size);
    
}

//lembre-se caramba de todas as entradas tem q carregar esses argumentos
/*
int main(){
    int entrada[17]={1,-2,3,8,4,-5,6,0,7,9,-10,11,-12,13,14,-15,16};
    int entrada2[17]={1,2,3,4,5,6,0,7,8,9,10,11,12,13,14,15,16};
    //int entrada[11]={4,3,0,1,2,-7,5,0,6,-8,9};
    //int entrada2[11]={1,2,3,0,4,5,0,6,7,8,9};
    //printf("Saida: %d \n", cromossomo(entrada, entrada2, (sizeof(entrada)/sizeof(int)) ,(sizeof(entrada2)/sizeof(int))));
    printf("saida:%d\n",is_cotail( entrada, entrada2,(sizeof(entrada)/sizeof(int)), (sizeof(entrada2)/sizeof(int))));
    load_genoma( entrada, entrada2,(sizeof(entrada)/sizeof(int)), (sizeof(entrada2)/sizeof(int)));
    
    identifyComponents(entrada,entrada2, (sizeof(entrada)/sizeof(int)));
    
    return 0;
}

*/







