/*
 ============================================================================
 Project     : Parallel Memetic Algorithm with Multi Populations no
 exchange individuals
 Author      : Lucas Angelo Silveira
 Universidade de Brasilia (UnB) - Brazil
 Group of Theory of Computation
 Version     : 1.0
 
 Last Modified On: February 01, 2016.
 ============================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "MAMPNE.h"
#include <mpi.h>
#include <time.h>//time
#include <sys/time.h>//time


int main(int argc, char** argv) {
    
    int seed[24] = {408302,680502,414942,829352,627420, 753780, 110291,444847, 127844, 525817,887214,115510,112376,510836,310830,390833,560813,260810,908811,414819,939819,287817,364410,194419};
    int seed2 = time(NULL);
    float parameter=0;
    struct timeval start, end;
    float tmili=0.0;
    int world_rank;
    MPI_Init(NULL, NULL);
    MPI_Comm_rank(MPI_COMM_WORLD, &world_rank);
    srand (seed[world_rank]+seed2);//initialize random generator
     gettimeofday(&start, NULL);
    MemetiAlg(MPI_COMM_WORLD, world_rank, parameter);
    gettimeofday(&end, NULL);
    tmili = (float) (1000.0 * (end.tv_sec - start.tv_sec) + (end.tv_usec - start.tv_usec) / 1000.0);
    
    if (world_rank==0) {
             printf("time:%.2f seconds\n", (tmili/1000.0));
    }
   
    MPI_Finalize();
    return 0;
}

